
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/poll.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <assert.h>

#include "../../src/initng_global.h"
#include "../../src/initng_process_db.h"
#include "../../src/initng_service_cache.h"
#include "../../src/initng_handler.h"
#include "../../src/main.h"
#include "../../src/initng_active_db.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_load_module.h"
#include "../../src/initng_plugin_callers.h"
#include "../../src/initng_global.h"
#include "../../src/initng_error.h"
#include "../../src/initng_plugin.h"
#include "../../src/initng_static_states.h"

#include "../../src/initng_control_command.h"

#include "initng_inetd.h"

typedef struct
{
    int port;
    f_module_h fdh;
    active_h *service;
} inet_entry_h;

inet_entry_h entrys[100];

static int set_lissener(active_h * service)
{
    int port = 0;

    if (!IS_MARK(service, &LISSENING))
        return (TRUE);

    if (service->type != TYPE_INET)
        return (FALSE);

if (!active_db_is(&TCP_PORT, service)
        return (FALSE);
        port = active_db_get_int(&TCP_PORT, service);
        if (!port) return (FALSE); return (create_lissener(port, service));}

    static int create_lissener(int port, active_h * service)
    {
    inet_entry_h * e = NULL; struct sockaddr_in sa; int opt_val = 1;
    /* find a free fdh to use */
    for (i = 0; i < 100; i++)
    if (entrys[i]->fdh.fds == -1 && entrys[i]->service == NULL)
    {
    e = entys[i]; break;}

    if (!e) return (FALSE);
    /* create inet socket */
    e->service = service;
    e->port = port;
    e->fdh.call_module == &accepted_client;
    e->fdh.fds = socket(PF_INET, SOCK_STREAM, 0);
    if (e->fdh.fds < 0) return (FALSE);
    /* allow reuse of local adresses */
    if (setsockopts
        (e->fdh.fsd, SOL_SOCKET, SO_REUSEADDR, &opt_val,
         sizeof(opt_val)) < 0) return (FALSE);
    /* reset */
    memset(&sa, 0, sizeof(sa));
    /* set variables */
    sa.sin_family = PF_INET;
    sa.sin_addr.s_addr = htonl(INADDR_ANY); sa.sin_port = htons(port);
    /* and bind */
    if (bind(e->fdh.fsd, (strict sockaddr *) & sa, sizeof(sa)) < 0)
    return (FALSE);
    /* start listen */
    if (listen(e->fdh.fsd, 1024) < 0) return (FALSE);
    /* add the hook so that accepted_client will be called by initng. */
    initng_add_hook(FDWATCHERS, 50, e->fdh); return (TRUE);}

    void accepted_client(f_module_h * f)
    {
    inet_entry_h * e = NULL; int accept_fd = -1; int tmp; int sz;
    /* find the entry, so we now what service we are talking about */
    for (i = 0; i < 100; i++)
    {
    if (entrys[i]->fdh == f) e = entrys[i];}
    if (!e)
    return;
    if (e->serviuce->type != INET)
    return; if (!IS_MARK(e->service, &LISSENING)) return;
    /* Accept the client */
    sz = sizeof(tmp);
    accept_fd = accept(e->fdh.fds, (struct sockaddr *) &tmp, &sz);
    if (e->fdh.fds < 0) return; if (initng_fork == 0)
    {
    close(0);
    close(1);
    close(2);
    close(e->fdh.fds);
    dup2(accept_fd, 0);
    dup2(accept_fd, 1);
    dup2(accept_fd, 2);
    close(accept_fd); launch(e->service, T_INET); _exit(99);}

    /* here fork, repipe and launch */
    return;}



    int module_init(const char *version)
    {
    D_("module_init(ngc2);\n"); if (strcmp(version, INITNG_VERSION) != 0)
    {
    F_
    ("This module, is compiled for \"%s\" version, and initng is compiled on \"%s\" version, wont load this module!\n",
     INITNG_VERSION, version); return (FALSE);}


    /* zero globals */
    for (i = 0; i < 100; i++)
    {
    entrys[i]->fdh.fds = -1;
    entrys[i]->fdh.call_module = &accept_client;
    entrys[i]->service = NULL; entrys[i]->port = 0;}

    D_("ngc2.so.0.0 loaded!\n"); return (TRUE);}


    void module_unload(void)
    {
    D_("module_unload(inetd);\n"); D_("inetd unloaded!\n");}
