
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng_active_db.h"
#include "../../src/initng_system_states.h"

#define SOCKET_FILENAME_REAL "/dev/initng/initng"
#define SOCKET_FILENAME_TEST "/dev/initng/initng-test"
#define SOCKET_ROOTPATH "/dev/initng/"

#define PROTOCOL_VERSION 3

int module_init(const char *version);
void module_unload(void);

int service_status(active_h * service);
void is_system_halt(h_sys_state state);

typedef struct
{
    char c;
    char l[101];
    e_com_type t;
    e_opt_type o;
    char d[101];
} help_row;

typedef struct
{
    char s[101];                /* status, a word describing the status */
    char n[101];                /* name of service */
    time_t t;                   /* time status set */
    e_is i;                     /* is status, status in a number */
} active_row;

typedef struct
{
    char n[101];
    e_dt t;
    char o[101];
    char d[301];
} option_row;

typedef enum
{
    S_FALSE = 0,
    S_TRUE = 1,
    S_REQUIRES_OPT = 2,
    S_NOT_REQUIRES_OPT = 3,
    S_INVALID_TYPE = 4,
    S_COMMAND_NOT_FOUND = 5
} e_suceed;

typedef struct
{
    e_suceed s;                 /* suceeed, TRUE or FALSE */
    char c;
    int t;                      /* type of data got back */
    char version[101];
    int p_ver;
} result_desc;

typedef struct
{
    char c;
    char l[101];
    char o[201];
    int p_ver;
} read_header;
