/* Initng, a next generatind sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include "../../src/initng_control_command.h"

static void cmd_fast_reload(char *arg, FILE * fd);


/* Warning.
 * Changing these variables, will make reload incompatible,
 * and probably hang initng
 */
#define MAX_SERVICE_NAME_STRING_LEN 200
#define MAX_DATA_STRING_LEN 200
#define MAX_TYPE_STRING_LEN 100
#define MAX_PROCESSES 6
#define MAX_PTYPE_STRING_LEN 100
#define MAX_ENTRYS_FOR_SERVICE 20

extern s_command FAST_RELOAD;
typedef struct
{
    char type[MAX_TYPE_STRING_LEN + 1];
    e_dt opt_type;
    union
    {
        char s[MAX_DATA_STRING_LEN + 1];
        int i;
    } t;
} r_d_e;

typedef struct
{
    char ptype[MAX_PTYPE_STRING_LEN + 1];
    int stdout1;
    int stdout2;
    int pid;
    int rcode;
} r_process;

/* this lines will the active contain */
typedef struct
{
    char name[MAX_SERVICE_NAME_STRING_LEN + 1];
    char type[MAX_TYPE_STRING_LEN + 1];
    char state[101];
    time_t time_got_status;

    /*  struct with some processes */
    r_process process[MAX_PROCESSES];

    /* struct with some data */
    r_d_e data[MAX_ENTRYS_FOR_SERVICE + 1];
} data_save_struct;


int module_init(const char *version);
void module_unload(void);
