
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERVICE_DB_H
#define SERVICE_DB_H

#include "initng_list.h"
#include "initng_service_types.h"
#include "initng_struct_data.h"
/* service type enum */
/*typedef enum
   {
   TYPE_UNKNOWN = 0,
   TYPE_SERVICE = 1,
   TYPE_CLASS = 2,
   TYPE_RUNLEVEL = 3,
   TYPE_VIRTUAL = 4,
   TYPE_DAEMON = 5,
   TYPE_CRON = 6
   } e_type; */

typedef struct s_service_h service_h;
struct s_service_h
{
    char *name;
    stype_h *type;

    /* list container, to store data */
    s_data data;

    /* father/relative data */
    char *father_name;
    service_h *father;

    /* add a list entry */
    struct list_head list;
};

/* service haneling functions */
int service_db_add(service_h * s);
service_h *service_db_copy(char *name, service_h * s);
service_h *service_db_new(char *name, stype_h * type);

/* Searching */
service_h *service_db_find_by_exact_name(const char *service);
service_h *service_db_find_by_name(const char *service);
service_h *service_db_find_in_name(const char *service);

int service_db_find_father(service_h * service);

/* freeing */
int service_db_free(service_h * to_free);
void service_db_free_all(void);

/* update */
void service_db_change(service_h * from, service_h * to);

/* standard wrappers using service */

/* statics */
#define service_db_is(t,s) service_db_is_var(t,NULL,s)
#define service_db_get_string(t,s) service_db_get_string_var(t, NULL, s)
#define service_db_get_int(t,s) service_db_get_int_var(t, NULL, s)
#define service_db_get_next_string(t,s,l) service_db_get_next_string_var(t,NULL,s,l)

#define service_db_set_string(type, from_service, string)  d_set_string(type, &from_service->data.list, string)
#define service_db_set_another_string(type, from_service, string) d_set_another_string(type, &from_service->data.list, string)
#define service_db_set_int(type, from_service, value) d_set_int(type, &from_service->data.list, value)
#define service_db_set(type, from_service) d_set(type, &from_service->data.list)
#define service_db_remove(type, from_service) d_remove(type, &from_service->data.list)

/* variable */
int service_db_is_var(s_entry * type, const char *vn, service_h * s);
char *service_db_get_string_var(s_entry * type, const char *vn,
                                service_h * s);
int service_db_get_int_var(s_entry * type, const char *vn, service_h * s);
char *service_db_get_next_string_var(s_entry * type, const char *vn,
                                     service_h * s, char *last);

#define service_db_set_string_var(type, vn, from_service, string)  d_set_string_var(type, vn, &from_service->data.list, string)
#define service_db_set_another_string_var(type, vn, from_service, string) d_set_another_string_var(type, vn, &from_service->data.list, string)
#define service_db_set_int_var(type, vn, from_service, value) d_set_int_var(type, vn, &from_service->data.list, value)
#define service_db_set_var(type, vn, from_service) d_set_var(type, vn, &from_service->data.list)
#define service_db_remove_var(type, vn, from_service) d_remove_var(type, vn, &from_service->data.list)


/* global */
#define service_db_remove_all(from_service) d_remove_all(&from_service->data.list)
#define service_db_count_type(type, from_service) d_count_type(type, &from_service->data.list)

/* service_list walker */
#define while_service_db(current) list_for_each_entry_prev(current, &g.service_cache.list, list)
#define while_service_db_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &g.service_cache.list, list)

#endif
